﻿Imports System.Text
Imports System.IO
Imports System.Runtime.InteropServices

Public Class Form1

    ' 일반 데이터 변수 선언
    Private m_iColPos As Integer() = New Integer(3) {}
    Private m_iValue1 As Integer = 0            ' int형 데이터 (4Byte)
    Private m_fValue1 As Single = 0             ' float형 데이터 (4Byte)
    Private m_strValue1 As String = ""          ' string(Unicode)형 데이터(6자리 최대12Byte)
    Private m_bySendData1 As Byte()             ' 송신 데이터 저장 바이트배열(구조체X)
    Private m_bySendData2 As Byte()             ' 송신 데이터 저장 바이트배열(구조체O)
    Private m_iSendCount As Integer             ' 반복 송신 카운트

    ' 구조체 멤버변수에 값을 전달할 임시 변수
    Private m_iValueTemp As Integer = 0
    Private m_fValueTemp As Single = 0
    Private m_strValueTemp As String = ""

    ' 구조체 ByteArray 선언
    Private Structure StructureData
        Public m_iValue2 As Integer             ' int형 데이터 (4Byte)
        Public m_fValue2 As Single              ' float형 데이터 (4Byte)
        Public m_byLength As Byte               ' m_strValue2의 사이즈 (1Byte)
        Public m_strValue2 As String            ' string(Unicode)형 데이터(최대6자리. 12Byte)
    End Structure

    ' 송신측 구조체 선언
    Private sSendStruct As StructureData
    ' 수신측 구조체 선언
    Private sRecvStruct As StructureData

    ' Port Number
    Private m_strPortNo As String() = {"COM1", "COM2", "COM3", "COM4", "COM7"}
    ' BaudRate
    Private m_strBaudRate As String() = {"110", "300", "600", "1200", "2400", "4800", "9600", "14400", "19200", "38400", "56000", "57600", "115200"}

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me

        ' ComboBox1에 포트번호 표시
        cmbPortNo.DataSource = m_strPortNo
        cmbPortNo.SelectItemIndex = 2

        ' ComboBox2에 통신포트 속도 초기값 표시
        cmbBaudRate.DataSource = m_strBaudRate
        cmbBaudRate.SelectItemIndex = 6

        ' SmartListBox Column스타일 지정
        Dim sColumnStyle As SmartX.SmartListBox.COLUMNSTYLE() = New SmartX.SmartListBox.COLUMNSTYLE(1) {}

        sColumnStyle(0).eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER
        sColumnStyle(0).iColumnWidth = 296
        sColumnStyle(0).iOffsetColumn = 0

        sColumnStyle(1).eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER
        sColumnStyle(1).iColumnWidth = 419
        sColumnStyle(1).iOffsetColumn = 0

        smartListBox1.ColumnStyles = sColumnStyle

        ' 일반 데이터 생성(송신용)
        ' int형 데이터 (4Byte)
        m_iValue1 = Convert.ToInt32(labInt1.Text)
        ' float형 데이터 (4Byte)
        m_fValue1 = Convert.ToSingle(labFloat1.Text)
        ' string(Unicode)형 데이터 (8Byte)
        m_strValue1 = labUnicode1.Text
        MakeNormalData(m_iValue1, m_fValue1, m_strValue1)

        ' 구조체 데이터 생성(송신용)
        ' int형 데이터 (4Byte)
        m_iValueTemp = Convert.ToInt32(labInt2.Text)
        ' float형 데이터 (4Byte)
        m_fValueTemp = Convert.ToSingle(labFloat2.Text)
        ' string(Unicode)형 데이터 (최대12Byte)
        m_strValueTemp = labUnicode2.Text
        MakeStructureData(m_iValueTemp, m_fValueTemp, m_strValueTemp)
    End Sub

    ' 통신포트 선택. COM3이 기본
    Private Sub cbPortNo_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles cmbPortNo.SelectedIndexChanged
        ' SmartComboBox에서 선택한 Item의 Index로 PortNo 속성값을 설정
        If cmbPortNo.SelectItemIndex = 4 Then
            SmartSerialPort1.PortNo = CType((cmbPortNo.SelectItemIndex + 3), SmartX.SmartSerialPort.COMPORTNO)
        Else
            SmartSerialPort1.PortNo = CType((cmbPortNo.SelectItemIndex + 1), SmartX.SmartSerialPort.COMPORTNO)
        End If
    End Sub

    ' BaudRate 선택. 9600bps가 기본
    Private Sub cbBaudRate_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles cmbBaudRate.SelectedIndexChanged
        ' SmartComboBox에서 선택한 Item의 Index로 Baud_Rate 속성값을 설정
        SmartSerialPort1.Baud_Rate = CType(Convert.ToInt32(cmbBaudRate.Text), SmartX.SmartSerialPort.BAUDRATE)
    End Sub

    ' 포트 Open
    Private Sub btnOpen_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnOpen.Click
        If SmartSerialPort1.IsOpen = False Then
            ' 에러 체크모드는 CRC32
            SmartSerialPort1.ErrorCheckMode = SmartX.SmartSerialPort.ERRORCHECK.CRC32
            ' 에러코드 위치는 TAIL
            SmartSerialPort1.ErrorCode_Location = SmartX.SmartSerialPort.ERRORCODELOCATION.TAIL
            ' 에러 체크 코드타입은 BINARY
            SmartSerialPort1.ErrorCheckCodeType = SmartX.SmartSerialPort.ERRORCHECKCODETYPES.BINARY
            ' 프레임 버퍼 사이즈
            SmartSerialPort1.FrameBufferSize = 3000000
            ' 프레임 구분은 STXONLY
            SmartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.STXONLY_READTIMEOUT
            Dim stxCods As Byte() = New Byte(1) {}
            stxCods(0) = &H2
            stxCods(1) = &H3
            SmartSerialPort1.STXCodes = stxCods
            ' 수신측 타임아웃 시간
            SmartSerialPort1.ReadTimeout = 50
            ' 데이터 수신은 이벤트 방식
            SmartSerialPort1.ReceiveDetect = SmartX.SmartSerialPort.RECEIVEDETECTTYPE.EVENT_QUEUE
            ' 수신 관련 함수에서 데이터만 출력
            SmartSerialPort1.ReceiveFrameDebugMode = False
            SmartSerialPort1.RS485SoftwareDetection = False

            SmartSerialPort1.Open()
            labPortStatus.Text = "Opened"
        End If
    End Sub

    ' 포트 Close
    Private Sub btnClose_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnClose.Click
        If SmartSerialPort1.IsOpen = True Then
            SmartSerialPort1.Close()
            labPortStatus.Text = "Closed"
        End If
    End Sub

    Private Sub btnExit_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnExit.Click
        btnClose_Click(sender, e)
        SmartForm1.Close()
    End Sub

    ' 송신 데이터 변경. int 최대 8자리, float 최대 10자리, string 최대 6자리로 제한
    Private Sub SmartLabel_Click(ByVal sender As Object, ByVal e As EventArgs) Handles labUnicode2.Click, labUnicode1.Click, labInt2.Click, labInt1.Click, labFloat2.Click, labFloat1.Click
        smartKeyboard1.Show(123, 269, CType(sender, SmartX.SmartLabel))
    End Sub

    ' Keyboard 입력이 끝났을 때 데이터 생성
    Private Sub smartKeyboard1_OnXKeyClick(ByVal sender As Object, ByVal e As EventArgs) Handles smartKeyboard1.OnXKeyClick
        ' 일반 데이터 생성(송신용)
        ' int형 데이터 (4Byte)
        m_iValue1 = Convert.ToInt32(labInt1.Text)
        ' float형 데이터 (4Byte)
        m_fValue1 = Convert.ToSingle(labFloat1.Text)
        ' string(Unicode)형 데이터 (8Byte)
        m_strValue1 = labUnicode1.Text
        MakeNormalData(m_iValue1, m_fValue1, m_strValue1)

        ' 구조체 데이터 생성(송신용)
        ' int형 데이터 (4Byte)
        m_iValueTemp = Convert.ToInt32(labInt2.Text)
        ' float형 데이터 (4Byte)
        m_fValueTemp = Convert.ToSingle(labFloat2.Text)
        ' string(Unicode)형 데이터 (최대12Byte)
        m_strValueTemp = labUnicode2.Text
        MakeStructureData(m_iValueTemp, m_fValueTemp, m_strValueTemp)

        smartKeyboard1.Hide()
        SmartForm1.Focus()
    End Sub

    ' 데이터 1회 송신
    Private Sub btnSend_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSend.Click
        If SmartSerialPort1.IsOpen = True Then
            If smartRadioButton1.Checked = True Then
                ' Send(STX + DATA + CRC32 + ETX) 구조체사용X
                SmartSerialPort1.WriteFrame(m_bySendData1)
            Else
                ' Send(STX + DATA + CRC32 + ETX) 구조체사용O
                SmartSerialPort1.WriteFrame(m_bySendData2)
            End If
        End If
    End Sub

    ' 데이터 반복 송신
    Private Sub btnAutoSend_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnAutoSend.Click
        m_iSendCount = 0
        ' 100 이하(0~10)인경우 수신시 데이터 깨질수있음
        SmartTimer1.Interval = 100
        SmartTimer1.Start()
    End Sub

    ' 데이터 반복 송신 타이머 Tick 이벤트
    Private Sub smartTimer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles SmartTimer1.Tick
        If m_iSendCount < 10 Then
            btnSend_Click(sender, e)
            m_iSendCount += 1
        Else
            SmartTimer1.Stop()
        End If
    End Sub

    ' 일반 데이터 생성 메서드
    Private Sub MakeNormalData(ByVal m_iValue1 As Integer, ByVal m_fValue1 As Single, ByVal m_strValue1 As String)
        ' 초기화
        labIntArray1.Text = ""
        labFloatArray1.Text = ""
        labUnicodeArray1.Text = ""

        ' int형 데이터 (4Byte)
        Dim bIntData1 As Byte() = BitConverter.GetBytes(m_iValue1)
        ' float형 데이터 (4Byte)
        Dim bFloatData1 As Byte() = BitConverter.GetBytes(m_fValue1)
        ' string(Unicode)형 데이터 (8Byte)
        Dim bStrData1 As Byte() = Encoding.Unicode.GetBytes(m_strValue1)
        Dim bStrData1Length As Byte() = New Byte(0) {}
        ' Unicode라서 *2해줌
        bStrData1Length(0) = Convert.ToByte(m_strValue1.Length * 2)
        ' 구조체 여부 체크
        Dim bCheckData1 As Byte() = New Byte(0) {}
        bCheckData1(0) = &H30

        ' 송신용 일반 데이터 m_bSendData1 생성. 사이즈는 구조체 멤버 변수 사이즈를 전부합한 사이즈
        m_bySendData1 = New Byte(bIntData1.Length + bFloatData1.Length + 1 + bStrData1.Length + 1 - 1) {}
        ' m_bSendData에 bIntData 복사
        Array.Copy(bIntData1, m_bySendData1, bIntData1.Length)
        ' m_bSendData에 bFloatData 연결하여 복사
        Array.Copy(bFloatData1, 0, m_bySendData1, bIntData1.Length, bFloatData1.Length)
        ' m_bSendData에 bFloatData 연결하여 복사
        Array.Copy(bStrData1Length, 0, m_bySendData1, bIntData1.Length + bFloatData1.Length, 1)
        ' m_bSendData에 bStrData1 연결하여 복사
        Array.Copy(bStrData1, 0, m_bySendData1, (bIntData1.Length + bFloatData1.Length + 1), bStrData1.Length)
        ' m_bSendData에 bStrData1 연결하여 복사
        Array.Copy(bCheckData1, 0, m_bySendData1, (bIntData1.Length + bFloatData1.Length + 1 + bStrData1.Length), bCheckData1.Length)

        ' int형 멤버변수를 Byte배열로 표현
        For i As Integer = 0 To 3
            labIntArray1.Text += String.Format("{0:X2}", m_bySendData1(i))
        Next

        ' float형 멤버변수를 Byte배열로 표현
        For i As Integer = 4 To 7
            labFloatArray1.Text += String.Format("{0:X2}", m_bySendData1(i))
        Next

        ' string형 멤버변수를 Byte배열로 표현
        For i As Integer = 9 To 9 + bStrData1.Length - 1
            labUnicodeArray1.Text += String.Format("{0:X2}", m_bySendData1(i))
        Next
    End Sub

    ' 구조체 데이터 생성 메서드(멤버변수 int, float, string으로 구성된 구조체)
    Private Sub MakeStructureData(ByVal m_iValueTemp As Integer, ByVal m_fValueTemp As Single, ByVal m_strValueTemp As String)
        ' 초기화
        labIntArray2.Text = ""
        labFloatArray2.Text = ""
        labUnicodeArray2.Text = ""

        ' 인자로 전달된 데이터를 구조체 멤버변수에 저장
        sSendStruct.m_iValue2 = m_iValueTemp
        sSendStruct.m_fValue2 = m_fValueTemp
        sSendStruct.m_strValue2 = m_strValueTemp

        ' m_strValue2의 사이즈. Unicode형태라서 곱하기2
        sSendStruct.m_byLength = CByte((sSendStruct.m_strValue2.Length * 2))
        ' 수신측에서 구조체 데이터인지 체크를 위한 구분 데이터
        Dim bCheckData2 As Byte() = New Byte(0) {}
        bCheckData2(0) = &H32

        ' 송신용 구조체 데이터 m_bSendData2 생성. 사이즈는 구조체 멤버 변수 사이즈를 전부합한 사이즈
        m_bySendData2 = New Byte(Marshal.SizeOf(sSendStruct.m_iValue2) + Marshal.SizeOf(sSendStruct.m_fValue2) + Marshal.SizeOf(sSendStruct.m_byLength) + sSendStruct.m_byLength + bCheckData2.Length - 1) {}
        ' Buffer.BlockCopy는 특정 오프셋에서 시작하는 소스 배열에서 특정 오프셋에서 시작하는 대상 배열로 지정된 바이트 수를 복사
        ' sSendStruct.m_iValue2를 m_bSendData2에 추가
        System.Buffer.BlockCopy(BitConverter.GetBytes(sSendStruct.m_iValue2), 0, m_bySendData2, 0, Marshal.SizeOf(GetType(Integer)))
        ' sSendStruct.m_fValue2를 m_bSendData2에 추가
        System.Buffer.BlockCopy(BitConverter.GetBytes(sSendStruct.m_fValue2), 0, m_bySendData2, Marshal.SizeOf(GetType(Integer)), Marshal.SizeOf(GetType(Single)))

        ' C나 C++의 경우 문자열의 끝을 NULL문자를 확인하여 구분하지만 C#의 경우 문자열의 앞부분에 문자열의 길이를 명시해야함
        ' sSendStruct.byLength를 m_bSendData2에 추가
        System.Buffer.BlockCopy(BitConverter.GetBytes(sSendStruct.m_byLength), 0, m_bySendData2, Marshal.SizeOf(GetType(Integer)) + Marshal.SizeOf(GetType(Single)), Marshal.SizeOf(GetType(Byte)))
        ' sSendStruct.m_strValue2를 m_bSendData2에 추가
        System.Buffer.BlockCopy(Encoding.Unicode.GetBytes(sSendStruct.m_strValue2), 0, m_bySendData2, Marshal.SizeOf(GetType(Integer)) + Marshal.SizeOf(GetType(Single)) + Marshal.SizeOf(GetType(Byte)), (sSendStruct.m_strValue2.Length * 2))
        ' bCheckData2를 m_bSendData2에 추가
        System.Buffer.BlockCopy(bCheckData2, 0, m_bySendData2, Marshal.SizeOf(GetType(Integer)) + Marshal.SizeOf(GetType(Single)) + Marshal.SizeOf(GetType(Byte)) + (sSendStruct.m_strValue2.Length * 2), bCheckData2.Length)

        ' 구조체의 int형 멤버변수를 Byte배열로 표현
        For i As Integer = 0 To 3
            labIntArray2.Text += String.Format("{0:X2}", m_bySendData2(i))
        Next

        ' 구조체의 float형 멤버변수를 Byte배열로 표현
        For i As Integer = 4 To 7
            labFloatArray2.Text += String.Format("{0:X2}", m_bySendData2(i))
        Next

        ' 구조체의 string형 멤버변수를 Byte배열로 표현
        For i As Integer = 9 To 9 + (sSendStruct.m_strValue2.Length * 2) - 1
            labUnicodeArray2.Text += String.Format("{0:X2}", m_bySendData2(i))
        Next
    End Sub

    ' 수신측. 인코딩(BYTE[] --> 구조체데이터). 리턴 타입이 ByteArray
    Private Shared Function ByteToStructure(ByVal data As Byte()) As StructureData
        Dim BinaryReader1 As StructureData = New StructureData()

        ' 기본 데이터 형식을 특정 인코딩의 이진 값으로 읽음
        Using reader As BinaryReader = New BinaryReader(New MemoryStream(data, False), Encoding.Unicode)
            ' 현재 스트림에서 부호있는 4바이트 정수를 읽기
            BinaryReader1.m_iValue2 = reader.ReadInt32()
            ' 현재 스트림에서 4바이트 부동 소수점 값을 읽기
            BinaryReader1.m_fValue2 = reader.ReadSingle()
            ' 현재 스트림에서 string데이터 읽기
            BinaryReader1.m_strValue2 = reader.ReadString()
        End Using

        Return BinaryReader1
    End Function

    ' 수신측 처리
    Private Function ReceiveData(ByVal bReadByte As Byte()) As String()
        ' Int형 데이터를 포함하는 Byte[]을 저장
        Dim bRecvInt1 As Byte() = New Byte(3) {}
        ' float형 데이터 포함하는 Byte[]을 저장
        Dim bRecvFloat1 As Byte() = New Byte(3) {}
        ' string(Unicode)형 데이터 포함하는 Byte[]을 저장
        Dim bRecvStr1 As Byte() = New Byte(bReadByte(8) - 1) {}
        Dim chkStruct As Boolean = False
        Dim strRet As String = ""
        Dim strRetByte As String = ""
        Dim strDataList As List(Of String) = New List(Of String)()

        ' 수신 데이터가 구조체 형태인지 일반 데이터인지 구분
        For i As Integer = 0 To bReadByte.Length - 1
            If 48 = bReadByte(i) Then
                ' 일반 데이터
                chkStruct = False
            ElseIf 50 = bReadByte(i) Then
                ' 구조체 데이터
                chkStruct = True
            End If
        Next

        Try

            If chkStruct = False Then
                ' 수신 데이터 파싱하는 부분
                ' 일반 데이터(구조체 사용X)

                ' Array.Copy를 사용하여 수신 데이터(bReadByte)를 데이터 형태별로 파싱
                Array.Copy(bReadByte, bRecvInt1, bRecvInt1.Length)
                Array.Copy(bReadByte, 4, bRecvFloat1, 0, bRecvFloat1.Length)
                Array.Copy(bReadByte, 9, bRecvStr1, 0, bRecvStr1.Length)

                ' 수신데이터를 각각의 원본데이터로 변환하여 strRet에 저장
                strRet += BitConverter.ToInt32(bRecvInt1, 0).ToString() & "  "
                strRet += BitConverter.ToSingle(bRecvFloat1, 0).ToString() & "  "
                strRet += Encoding.Unicode.GetString(bRecvStr1, 0, bRecvStr1.Length)
                strDataList.Add(strRet)

                ' Byte배열의 bRecvInt1부분을 string 포맷으로 표현
                For i As Integer = 0 To bRecvInt1.Length - 1
                    strRetByte += String.Format("{0:X2}", bRecvInt1(i))

                    If i <> bRecvInt1.Length - 1 Then
                        strRetByte += "-"
                    End If
                Next

                strRetByte += "  "

                ' Byte배열의 bRecvFloat1부분을 string포맷으로 표현
                For i As Integer = 0 To bRecvFloat1.Length - 1
                    strRetByte += String.Format("{0:X2}", bRecvFloat1(i))

                    If i <> bRecvFloat1.Length - 1 Then
                        strRetByte += "-"
                    End If
                Next

                strRetByte += "  "

                ' Byte배열의 bRecvStr1부분을 string포맷으로 표현
                For i As Integer = 0 To bRecvStr1.Length - 1
                    strRetByte += String.Format("{0:X2}", bRecvStr1(i))

                    If i <> bRecvStr1.Length - 1 Then
                        strRetByte += "-"
                    End If
                Next

                strDataList.Add(strRetByte)
            Else
                ' 구조체 데이터
                ' 수신데이터를 각각의 원본 데이터로 변환하여 strRet에 저장
                sRecvStruct = ByteToStructure(bReadByte)
                strRet += sRecvStruct.m_iValue2.ToString() & "  "
                strRet += sRecvStruct.m_fValue2.ToString() & "  "
                strRet += sRecvStruct.m_strValue2
                strDataList.Add(strRet)

                ' Byte배열의 sRecvStruct.m_iValue2 부분을 string포맷으로 표현
                For i As Integer = 0 To 3
                    strRetByte += String.Format("{0:X2}", bReadByte(i))

                    If i <> 3 Then
                        strRetByte += "-"
                    End If
                Next

                strRetByte += "  "

                ' Byte배열의 sRecvStruct.m_fValue2부분을 string포맷으로 표현
                For i As Integer = 4 To 7
                    strRetByte += String.Format("{0:X2}", bReadByte(i))

                    If i <> 7 Then
                        strRetByte += "-"
                    End If
                Next

                strRetByte += "  "

                ' Byte배열의 sRecvStruct.m_strValue2부분을 string포맷으로 표현
                For i As Integer = 9 To 9 + (sRecvStruct.m_strValue2.Length * 2) - 1
                    strRetByte += String.Format("{0:X2}", bReadByte(i))

                    If i <> 9 + (sRecvStruct.m_strValue2.Length * 2) - 1 Then
                        strRetByte += "-"
                    End If
                Next

                strDataList.Add(strRetByte)
            End If

        Catch __unusedException1__ As Exception
            MessageBox.Show("Exception")
        End Try

        Return strDataList.ToArray()
    End Function

    ' 데이터 수신 이벤트
    Private Sub smartSerialPort1_OnReadQueueEvent() Handles SmartSerialPort1.OnReadQueueEvent
        ' 수신데이터 저장 Byte[]
        Dim readByte As Byte()
        Dim eStatus As SmartX.SmartSerialPort.FRAMEDATAREADSTATUS
        eStatus = SmartSerialPort1.ReadQueue(readByte)

        If eStatus = SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.VALIDDATA Then
            smartListBox1.AddItem(ReceiveData(readByte))
            labRecvCnt.Text = smartListBox1.ItemCount.ToString()
        End If
    End Sub

    Private Sub btnListClear_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnListClear.Click
        smartListBox1.ClearAll()
    End Sub
End Class
